package com.zksy.data.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zksy.common.exception.DbException;
import com.zksy.data.annotation.XhDataLogRecord;
import com.zksy.data.domain.po.XcrEquityChange;
import com.zksy.data.domain.response.XcrEquityChangeResponse;
import com.zksy.data.mapper.XcrEquityChangeMapper;
import com.zksy.data.service.XcrEquityChangeService;
import com.zksy.data.utils.RedisService;
import com.zksy.data.utils.XhRequestUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.support.TransactionTemplate;

import java.util.List;
import java.util.Vector;

/**
* @author Administrator
* @description 针对表【xcr_equity_change(股权出质变更信息)】的数据库操作Service实现
* @createDate 2024-09-29 16:54:18
*/
@Service
@Slf4j
public class XcrEquityChangeServiceImpl extends ServiceImpl<XcrEquityChangeMapper, XcrEquityChange>
    implements XcrEquityChangeService{

    @Autowired
    private XhRequestUtil xhRequestUtil;
    @Autowired
    private RedisService redisService;
    @Autowired
    private TransactionTemplate transactionTemplate;

    @Override
    @XhDataLogRecord("同步股权出质变更信息")
    public void saveDataByUniCode(String address) {
        //模拟从数据库中取数据大约为3000-4000条
        List<String> creditCodes = (List<String>) redisService.getList("creditCodes").get(0);
        Vector<XcrEquityChange> toDatabaseList = new Vector<>();
        creditCodes.parallelStream().forEach(creditCode -> {
            List<XcrEquityChange> list = xhRequestUtil.httpRequestByUniCode(creditCode, address,
                    XcrEquityChangeResponse.class,
                    XcrEquityChange.class
            );
            if(list != null){
                toDatabaseList.addAll(list);
            }
        });
        transactionTemplate.execute((s)->{
            try {
                this.remove(null);
                this.saveBatch(toDatabaseList);
            } catch (Exception e) {
                s.setRollbackOnly();
                throw new DbException(e);
            }
            return null;
        });
        log.info("股权出质变更信息同步完成");
    }
}




